=== debian/changelog ===
ulfius (2.7.13-1) unstable; urgency=medium

  * New upstream release
  * d/patches/doc.patch: Update doxygen patch

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Feb 2023 12:04:54 -0500

ulfius (2.7.12-1) unstable; urgency=medium

  * d/control: Update Standards-Version to 4.6.2
  * d/libulfius-dev.install: Add cmake dependencies
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Mon, 09 Jan 2023 07:46:52 -0500

ulfius (2.7.11-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.1
  * d/symbols: update symbols
  * d/tests: add unit test

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:20:19 -0400
