## ulfius 2.7.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/ulfius/issues")
 set(LIBRARY_VERSION_MAJOR "2")
 set(LIBRARY_VERSION_MINOR "7")
-set(LIBRARY_VERSION_PATCH "13")
+set(LIBRARY_VERSION_PATCH "14")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -58,8 +58,8 @@
 
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(ORCANIA_VERSION_REQUIRED "2.3.2")
-set(YDER_VERSION_REQUIRED "1.4.19")
+set(ORCANIA_VERSION_REQUIRED "2.3.3")
+set(YDER_VERSION_REQUIRED "1.4.20")
 set(JANSSON_VERSION_REQUIRED "2.1")
 
 # cmake modules
@@ -272,46 +272,11 @@
 
 # dependencies
 
-option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)
-
-option(SEARCH_ORCANIA_U "Search for ORCANIA library" ON)
-if (SEARCH_ORCANIA_U)
-    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
-    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
-    if (NOT Orcania_FOUND)
-        if (DOWNLOAD_DEPENDENCIES)
-            include(DownloadProject)
-            download_project(PROJ orcania # ... otherwise, download archive
-                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
-                             QUIET)
-            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
-            # The following lines can be removed once Orcania has full target support
-            if (TARGET orcania)
-                if (NOT TARGET Orcania::Orcania)
-                    add_library(Orcania::Orcania INTERFACE IMPORTED)
-                    set_target_properties(Orcania::Orcania PROPERTIES
-                            INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
-                            INTERFACE_LINK_LIBRARIES orcania)
-                endif ()
-            endif ()
-            if (TARGET orcania_static)
-                if (NOT TARGET Orcania::Orcania-static)
-                    add_library(Orcania::Orcania-static INTERFACE IMPORTED)
-                    set_target_properties(Orcania::Orcania-static PROPERTIES
-                        INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
-                        INTERFACE_LINK_LIBRARIES orcania-_static)
-                endif ()
-            endif ()
-        else ()
-            message( FATAL_ERROR "Orcania not found")
-        endif ()
-    else()
-        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
-            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
-        else ()
-            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
-        endif ()
-    endif ()
+find_package(Orcania ${ORCANIA_VERSION_REQUIRED} REQUIRED)
+if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
+    message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
+else ()
+    message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
 endif ()
 
 if (BUILD_SHARED)
@@ -325,20 +290,76 @@
     endif()
 endif ()
 
-option(WITH_YDER "Use Yder library to log messages" ON)
-option(SEARCH_YDER "Search for Yder library" ON)
-
-if (WITH_YDER)
-    set(U_DISABLE_YDER OFF)
-    set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download
-
-    if (SEARCH_YDER)
-        set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
-        find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
-        if (NOT Yder_FOUND)
-            if (DOWNLOAD_DEPENDENCIES)
-                include(DownloadProject)
-                download_project(PROJ yder # ... otherwise, download archive
-                                  URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
-                                  QUIET)
-                add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
+find_package(Yder ${YDER_VERSION_REQUIRED} REQUIRED)
+if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
+    message(STATUS "Yder found: ${YDER_VERSION_STRING}")
+else ()
+    message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
+endif ()
+
+if (BUILD_SHARED)
+    target_link_libraries(ulfius PUBLIC $<TARGET_NAME:Yder::Yder>)
+endif ()
+if (BUILD_STATIC)
+    if(TARGET Yder::Yder-static)
+        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Yder::Yder-static>)
+    else()
+        target_link_libraries(ulfius_static PUBLIC $<TARGET_NAME:Yder::Yder>)
+    endif()
+endif ()
+
+# build uwsc
+
+cmake_dependent_option(BUILD_UWSC "Build uwsc application." ON "WITH_WEBSOCKET" OFF)
+
+if (BUILD_UWSC)
+    add_executable(uwsc ${UWSC_DIR}/uwsc.c ${INC_DIR}/ulfius.h ${INC_DIR}/u_private.h ${PROJECT_BINARY_DIR}/ulfius-cfg.h)
+    set_target_properties(uwsc PROPERTIES SKIP_BUILD_RPATH TRUE)
+    add_dependencies(uwsc ulfius)
+    target_link_libraries(uwsc PRIVATE "${ulfius_lib}")
+    target_compile_options(uwsc PRIVATE -Wextra -Wconversion)
+    install(TARGETS uwsc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    INSTALL(FILES ${UWSC_DIR}/uwsc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
+endif ()
+
+set(PKGCONF_REQ "")
+set(PKGCONF_REQ_PRIVATE "liborcania, libyder")
+if (WITH_CURL)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libcurl")
+endif ()
+if (WITH_JANSSON)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, jansson")
+endif ()
+if (WITH_GNUTLS)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, gnutls >= 3.5.0")
+endif ()
+if (WITH_WEBSOCKET)
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libmicrohttpd >= 0.9.53")
+else ()
+  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libmicrohttpd >= 0.9.51")
+endif ()
+
+# build ulfius-cfg.h file
+configure_file(${INC_DIR}/ulfius-cfg.h.in ${PROJECT_BINARY_DIR}/ulfius-cfg.h)
+set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
+
+# tests
+
+option(BUILD_ULFIUS_TESTING "Build the testing tree." OFF) # because we do not use include(CTest)
+
+if (BUILD_ULFIUS_TESTING)
+    find_package(Check REQUIRED)
+    if (CHECK_FOUND)
+        if (NOT WIN32 AND NOT APPLE)
+            include(FindSubunit)
+            find_package(Subunit REQUIRED)
+        endif ()
+
+        enable_testing()
+
+        set(CMAKE_CTEST_COMMAND ctest -V)
+
+        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
+        set(EXAMPLE_CALLBACK_COMPRESSION_DIR ${CMAKE_CURRENT_SOURCE_DIR}/example_callbacks/http_compression/)
+        set(EXAMPLE_CALLBACK_STATIC_FILE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/example_callbacks/static_compressed_inmemory_website/)
+        set(TEST_LIBS Ulfius::Ulfius Check::Check)
