=== debian/changelog ===
ulfius (2.7.14-1A~5.2.0.202412031725) ucs5-2-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    00_version_bump.patch

 -- Univention builddaemon <buildd@univention.de>  Tue, 03 Dec 2024 17:25:51 -0000

ulfius (2.7.14-1) unstable; urgency=medium

  * New upstream release
  * d/patches/doc.patch: Update doxygen patch (Closes: #1045534)
  * d/rules: remove doc/html and generated key files in test/cert during dh_clean
  * d/copyright: Remove superfluous files
  * d/rules: Remove configure option -DDOWNLOAD_DEPENDENCIES=OFF

 -- Nicolas Mora <babelouest@debian.org>  Thu, 21 Sep 2023 19:54:22 -0400
